module mgetc3
   use precision, only: ki
   use constants
   use options
   use mfunctions
   use mrestore
   implicit none

contains

      subroutine getc3(numeval,nleg,rank,c3,cut3,&
     & q1,q2,q3,q4,q5,q6,q7,q8,q9,q10,qt,Vi,msq)
      implicit none
      integer :: i,j,k,m,i1,i2,i3,i4,i5,cut3,dicut5,dicut4,mx,j1,j2,j3
      integer :: nleg,rank,diff
      real(ki), dimension(0:nleg-1):: msq
      real(ki), dimension(0:nleg-1,4) ::Vi
      real(ki) :: C0,C1,MP12,mu2,KK,Kmu
      complex(ki), dimension(10) :: dens3,dens4,dens5,xneval
      complex(ki), dimension(10) :: resi5,resi4,known
      complex(ki) :: c3(0:9), f3(0:9) 
      complex(ki), dimension(4) :: q1,q2,q3,q4,q5,q6,q7,q8,q9,q10,qt
      complex(ki) :: dens3t,dens4t,dens5t,resit
      complex(ki) :: numeval
      logical evalres 

      common/C0C1/C0,C1,mu2,MP12,KK,Kmu
      common/t3/resit,dens3t

      j3=cut3/100
      j2=(cut3-j3*100)/10
      j1=cut3-j3*100-j2*10

      do j=1,10
         resi5(j)=czip
         resi4(j)=czip
         known(j)=czip
         xneval(j)=czip
         dens3(j)=cone
      enddo

!---  for lnntest
      resit=czip
      dens3t=cone

!---  for simplified sampling
      diff = nleg-rank

      if (diff.ge.3) then
! simplified sampling -- only c3(0)

         if     (nleg.eq.5) then
            resi5(1)=res5(1,zip)
            resit=res5(1,half)
            goto 11

         elseif (nleg.eq.4) then
         resi4(1)=Res4(1,q1,zip)
         resit   =res4(1,qt,half)
         goto 21

      elseif (nleg.eq.3) then
         goto 26

      else
         
         dicut5=1
         do i5=4,nleg-1
            do i4=3,i5-1
               do i3=2,i4-1
                  do i2=1,i3-1
                     do i1=0,i2-1

                        dens5(1)=cone
                        dens5t=cone
                        
                        evalres=.false.
      
      do i=0,nleg-1
      if (((i).eq.(i1)).or.((i).eq.(i2)) &
     & .or.((i).eq.(i3)).or.((i).eq.(i4)).or.((i).eq.(i5))) then
           goto 5
      else
       if (((i).eq.(j1)).or.((i).eq.(j2)).or.((i).eq.(j3))) then
          dens5(1)=czip
          dens5t=czip
        evalres=.false.
        goto 10
       else
        dens5(1)=dens5(1)*denevalmu2(nleg,i,q1,Vi,msq,zip)
        dens5t=dens5t*denevalmu2(nleg,i,qt,Vi,msq,half)
        evalres=.true.
       endif
      endif
 5      continue
      enddo
 10   continue

      if (evalres) then
         resi5(1)=resi5(1)+dens5(1)*res5(dicut5,zip)
         resit=resit+dens5t*Res5(dicut5,half)
      endif

          dicut5=dicut5+1
          enddo
         enddo
        enddo
       enddo
      enddo

      endif

 11   continue

      dicut4=1
      do i4=3,nleg-1
       do i3=2,i4-1
        do i2=1,i3-1
         do i1=0,i2-1

            dens4(1)=cone
            dens4t=cone

      evalres=.false.
      
      do i=0,nleg-1
      if (((i).eq.(i1)).or.((i).eq.(i2)) &
     &  .or.((i).eq.(i3)).or.((i).eq.(i4))) then
           goto 15
      else
       if (((i).eq.(j1)).or.((i).eq.(j2)).or.((i).eq.(j3))) then
          dens4(1)=czip
          dens4t=czip
        evalres=.false.
        goto 20
       else
        dens4(1)=dens4(1)*denevalmu2(nleg,i,q1,Vi,msq,zip)
        dens4t=dens4t*denevalmu2(nleg,i,qt,Vi,msq,half)
        evalres=.true.
       endif
      endif
 15   continue
      enddo
 20   continue

      if (evalres) then
         resi4(1)=resi4(1)+dens4(1)*Res4(dicut4,q1,zip)
         resit=resit+dens4t*Res4(dicut4,qt,half)
      endif

          dicut4=dicut4+1
         enddo
        enddo
       enddo
      enddo

 21    continue

      do i=0,nleg-1
        if (((i).eq.(j1)).or.((i).eq.(j2)).or.((i).eq.(j3))) then
           goto 25
        else
        dens3(1)=dens3(1)*denevalmu2(nleg,i,q1,Vi,msq,zip)
        dens3t=dens3t*denevalmu2(nleg,i,qt,Vi,msq,half)
        endif
 25     continue
      enddo

 26   continue

      xneval(1)=numeval(cut3,q1,zip)
      if     (imeth.eq.'diag') then
      known(1)=(xneval(1)-resi5(1)-resi4(1))/dens3(1)
      elseif (imeth.eq.'tree') then
      known(1)=xneval(1)-(resi5(1)+resi4(1))/dens3(1)
      endif
 
      c3(0)=known(1)
      do m=1,9
         c3(m)=czip
      enddo

     
!--- Decomposizione standard
      else

      if     (nleg.eq.5) then
         resi5(1)=Res5(1,zip)
         resi5(2)=Res5(1,zip)
         resi5(3)=Res5(1,zip)
         resi5(4)=Res5(1,zip)
         resi5(5)=Res5(1,zip)
         resi5(6)=Res5(1,zip)
         resi5(7)=Res5(1,zip)
         resi5(8)=Res5(1,mu2)
         resi5(9)=Res5(1,mu2)
         resi5(10)=Res5(1,mu2)         
         resit=Res5(1,half)         
         goto 111

      elseif (nleg.eq.4) then
         resi4(1)=Res4(1,q1,zip)
         resi4(2)=Res4(1,q2,zip)
         resi4(3)=Res4(1,q3,zip)
         resi4(4)=Res4(1,q4,zip)
         resi4(5)=Res4(1,q5,zip)
         resi4(6)=Res4(1,q6,zip)
         resi4(7)=Res4(1,q7,zip)
         resi4(8)=Res4(1,q8,mu2)
         resi4(9)=Res4(1,q9,mu2)
         resi4(10)=Res4(1,q10,mu2)         
         resit=Res4(1,qt,half)         
         goto 121

      elseif (nleg.eq.3) then
         goto 126

      else

      dicut5=1
      do i5=4,nleg-1
       do i4=3,i5-1
        do i3=2,i4-1
         do i2=1,i3-1
          do i1=0,i2-1

      do j=1,10
      dens5(j)=cone
      enddo
      dens5t=cone

      evalres=.false.
      
      do i=0,nleg-1
      if (((i).eq.(i1)).or.((i).eq.(i2)) &
     & .or.((i).eq.(i3)).or.((i).eq.(i4)).or.((i).eq.(i5))) then
           goto 105
      else
       if (((i).eq.(j1)).or.((i).eq.(j2)).or.((i).eq.(j3))) then
          do k=1,10
             dens5(k)=czip
          enddo
             dens5t=czip

        evalres=.false.
        goto 110
       else
        dens5(1)=dens5(1)*denevalmu2(nleg,i,q1,Vi,msq,zip)
        dens5(2)=dens5(2)*denevalmu2(nleg,i,q2,Vi,msq,zip)
        dens5(3)=dens5(3)*denevalmu2(nleg,i,q3,Vi,msq,zip)
        dens5(4)=dens5(4)*denevalmu2(nleg,i,q4,Vi,msq,zip)
        dens5(5)=dens5(5)*denevalmu2(nleg,i,q5,Vi,msq,zip)
        dens5(6)=dens5(6)*denevalmu2(nleg,i,q6,Vi,msq,zip)
        dens5(7)=dens5(7)*denevalmu2(nleg,i,q7,Vi,msq,zip)
        dens5(8)=dens5(8)*denevalmu2(nleg,i,q8,Vi,msq,mu2)
        dens5(9)=dens5(9)*denevalmu2(nleg,i,q9,Vi,msq,mu2)
        dens5(10)=dens5(10)*denevalmu2(nleg,i,q10,Vi,msq,mu2)
        dens5t=dens5t*denevalmu2(nleg,i,qt,Vi,msq,half)
        evalres=.true.
       endif
      endif
 105      continue
      enddo
 110   continue

      if (evalres) then

         resi5(1)=resi5(1)+dens5(1)*res5(dicut5,zip)
         resi5(2)=resi5(2)+dens5(2)*res5(dicut5,zip)
         resi5(3)=resi5(3)+dens5(3)*res5(dicut5,zip)
         resi5(4)=resi5(4)+dens5(4)*res5(dicut5,zip)
         resi5(5)=resi5(5)+dens5(5)*res5(dicut5,zip)
         resi5(6)=resi5(6)+dens5(6)*res5(dicut5,zip)
         resi5(7)=resi5(7)+dens5(7)*res5(dicut5,zip)
         resi5(8)=resi5(8)+dens5(8)*res5(dicut5,mu2)
         resi5(9)=resi5(9)+dens5(9)*res5(dicut5,mu2)
         resi5(10)=resi5(10)+dens5(10)*res5(dicut5,mu2)
         resit=resit+dens5t*res5(dicut5,half)

      endif

          dicut5=dicut5+1
          enddo
         enddo
        enddo
       enddo
      enddo


      endif

 111   continue



      dicut4=1
      do i4=3,nleg-1
       do i3=2,i4-1
        do i2=1,i3-1
         do i1=0,i2-1

      do j=1,10
      dens4(j)=cone
      enddo
      dens4t=cone

      evalres=.false.
      
      do i=0,nleg-1
      if (((i).eq.(i1)).or.((i).eq.(i2)) &
     &  .or.((i).eq.(i3)).or.((i).eq.(i4))) then
           goto 115
      else
       if (((i).eq.(j1)).or.((i).eq.(j2)).or.((i).eq.(j3))) then
          do k=1,10
          dens4(k)=czip
          enddo
          dens4t=czip
  
      evalres=.false.
        goto 120
       else
        dens4(1)=dens4(1)*denevalmu2(nleg,i,q1,Vi,msq,zip)
        dens4(2)=dens4(2)*denevalmu2(nleg,i,q2,Vi,msq,zip)
        dens4(3)=dens4(3)*denevalmu2(nleg,i,q3,Vi,msq,zip)
        dens4(4)=dens4(4)*denevalmu2(nleg,i,q4,Vi,msq,zip)
        dens4(5)=dens4(5)*denevalmu2(nleg,i,q5,Vi,msq,zip)
        dens4(6)=dens4(6)*denevalmu2(nleg,i,q6,Vi,msq,zip)
        dens4(7)=dens4(7)*denevalmu2(nleg,i,q7,Vi,msq,zip)
        dens4(8)=dens4(8)*denevalmu2(nleg,i,q8,Vi,msq,mu2)
        dens4(9)=dens4(9)*denevalmu2(nleg,i,q9,Vi,msq,mu2)
        dens4(10)=dens4(10)*denevalmu2(nleg,i,q10,Vi,msq,mu2)
        dens4t=dens4t*denevalmu2(nleg,i,qt,Vi,msq,half)
        evalres=.true.
       endif
      endif
 115     continue
      enddo
 120   continue

      if (evalres) then
         resi4(1)=resi4(1)+dens4(1)*Res4(dicut4,q1,zip)
         resi4(2)=resi4(2)+dens4(2)*Res4(dicut4,q2,zip)
         resi4(3)=resi4(3)+dens4(3)*Res4(dicut4,q3,zip)
         resi4(4)=resi4(4)+dens4(4)*Res4(dicut4,q4,zip)
         resi4(5)=resi4(5)+dens4(5)*Res4(dicut4,q5,zip)
         resi4(6)=resi4(6)+dens4(6)*Res4(dicut4,q6,zip)
         resi4(7)=resi4(7)+dens4(7)*Res4(dicut4,q7,zip)
         resi4(8)=resi4(8)+dens4(8)*Res4(dicut4,q8,mu2)
         resi4(9)=resi4(9)+dens4(9)*Res4(dicut4,q9,mu2)
         resi4(10)=resi4(10)+dens4(10)*Res4(dicut4,q10,mu2)
         resit=resit+dens4t*Res4(dicut4,qt,half)
      endif

          dicut4=dicut4+1
         enddo
        enddo
       enddo
      enddo

 121    continue

      do i=0,nleg-1
        if (((i).eq.(j1)).or.((i).eq.(j2)).or.((i).eq.(j3))) then
           goto 125
        else
        dens3(1)=dens3(1)*denevalmu2(nleg,i,q1,Vi,msq,zip)
        dens3(2)=dens3(2)*denevalmu2(nleg,i,q2,Vi,msq,zip)
        dens3(3)=dens3(3)*denevalmu2(nleg,i,q3,Vi,msq,zip)
        dens3(4)=dens3(4)*denevalmu2(nleg,i,q4,Vi,msq,zip)
        dens3(5)=dens3(5)*denevalmu2(nleg,i,q5,Vi,msq,zip)
        dens3(6)=dens3(6)*denevalmu2(nleg,i,q6,Vi,msq,zip)
        dens3(7)=dens3(7)*denevalmu2(nleg,i,q7,Vi,msq,zip)
        dens3(8)=dens3(8)*denevalmu2(nleg,i,q8,Vi,msq,mu2)
        dens3(9)=dens3(9)*denevalmu2(nleg,i,q9,Vi,msq,mu2)
        dens3(10)=dens3(10)*denevalmu2(nleg,i,q10,Vi,msq,mu2)
        dens3t=dens3t*denevalmu2(nleg,i,qt,Vi,msq,half)
        endif
 125     continue
      enddo

 126   continue

      xneval(1)=numeval(cut3,q1,zip)
      xneval(2)=numeval(cut3,q2,zip)
      xneval(3)=numeval(cut3,q3,zip)
      xneval(4)=numeval(cut3,q4,zip)
      xneval(5)=numeval(cut3,q5,zip)
      xneval(6)=numeval(cut3,q6,zip)
      xneval(7)=numeval(cut3,q7,zip)
      xneval(8)=numeval(cut3,q8,mu2)
      xneval(9)=numeval(cut3,q9,mu2)
      xneval(10)=numeval(cut3,q10,mu2)

      if     (imeth.eq.'diag') then
      do k=1,10
      known(k)=(xneval(k)-resi5(k)-resi4(k))/dens3(k)
      enddo
      elseif (imeth.eq.'tree') then
      do k=1,10
      known(k)=xneval(k)-(resi5(k)+resi4(k))/dens3(k)
      enddo
      endif

       do m=0,3
       f3(m)=effe(known,1,4,m)
       enddo

       do m=4,6
       mx=m-4
       f3(m)=effe(known,5,3,mx)
       enddo

       do m=7,9
       mx=m-7
       f3(m)=effe(known,8,3,mx)
       enddo

!--- coefficienti
      c3(0) =  &
     &f3(0)
      c3(1) =  &
     &        -((KK*(C0**5*f3(1) + C0**2*f3(2) + C0**11*f3(3) +  &
     &        C0**8*(f3(0) - f3(4)) - C0**4*f3(5) - f3(6)))/ &
     &    ((-one + C0**12)*MP12))
      c3(2) =  &
     &        (KK**2*(C0*f3(1) + C0**10*f3(2) + C0**7*f3(3) +  &
     &      C0**4*(f3(0) - f3(4)) - f3(5) - C0**8*f3(6)))/ &
     &  ((-one + C0**12)*MP12**2)
      c3(3) =  &
     &        -((KK**3*(f3(0) + C0**9*f3(1) + C0**6*f3(2) +  &
     &        C0**3*f3(3) - f3(4) - C0**8*f3(5) - C0**4*f3(6)))/ &
     &    ((-one + C0**12)*MP12**3))
      c3(4) =  &
     &        (f3(1) + C0**9*f3(2) + C0**6*f3(3) +  &
     &    C0**3*(f3(0) - f3(4)) - C0**11*f3(5) - C0**7*f3(6))/ &
     &  ((-one + C0**12)*KK*MP12)
      c3(5) =  &
     &        (-(C0**3*f3(1)) - f3(2) - C0**9*f3(3) +  &
     &    C0**6*(-f3(0) + f3(4)) + C0**2*f3(5) + C0**10*f3(6))/ &
     &  ((-one + C0**12)*KK**2*MP12**2)
      c3(6) =  &
     &        (C0**6*f3(1) + C0**3*f3(2) + f3(3) +  &
     &    C0**9*(f3(0) - f3(4)) - C0**5*f3(5) - C0*f3(6))/ &
     &  ((-one + C0**12)*KK**3*MP12**3)
      c3(7) =  &
     &        ((C1**3*KK**3*(C0**6*f3(1) + C0**3*f3(2) + f3(3) +  &
     &         C0**9*(f3(0) - f3(4)) - C0**5*f3(5) - C0*f3(6)))/ &
     &     (-one + C0**12) -  &
     &    (KK**3*(f3(0) + C0**9*f3(1) + C0**6*f3(2) +  &
     &         C0**3*f3(3) - f3(4) - C0**8*f3(5) - C0**4*f3(6)))/ &
     &     (-one + C0**12) + KK**3*(-f3(0) + f3(7)))/(KK**3*mu2)
      c3(8) =  &
     &        -((-((KK*(C0**5*f3(1) + C0**2*f3(2) + C0**11*f3(3) +  &
     &             C0**8*(f3(0) - f3(4)) - C0**4*f3(5) - f3(6)))/ &
     &         (-one + C0**12)) -  &
     &      (C1**2*KK*(-(C0**3*f3(1)) - f3(2) - C0**9*f3(3) +  &
     &           C0**6*(-f3(0) + f3(4)) + C0**2*f3(5) +  &
     &           C0**10*f3(6)))/(-one + C0**12) + KK*f3(9))/ &
     &    (MP12*mu2))
      c3(9) =  &
     &        (-((C1*KK**2*(f3(1) + C0**9*f3(2) + C0**6*f3(3) +  &
     &           C0**3*(f3(0) - f3(4)) - C0**11*f3(5) -  &
     &           C0**7*f3(6)))/(-one + C0**12)) +  &
     &    (KK**2*(C0*f3(1) + C0**10*f3(2) + C0**7*f3(3) +  &
     &         C0**4*(f3(0) - f3(4)) - f3(5) - C0**8*f3(6)))/ &
     &     (-one + C0**12) - KK**2*f3(8))/(C1*KK**3*MP12*mu2)

      endif
      

      if (diff.ge.1) then
         c3(3)=czip
         c3(6)=czip
         c3(8)=czip
         c3(9)=czip 
         if (diff.ge.2) then
            c3(2)=czip
            c3(5)=czip
            c3(7)=czip
            if (diff.ge.3) then
               c3(1)=czip
               c3(4)=czip
            endif 
         endif 
      endif


  end subroutine getc3
end module mgetc3

