module mrestore
   use precision
   use constants
   use save
   use mfunctions
   implicit none

contains
  subroutine store5(icut5,cut5,p0,e1,e2,e3,e4,c5)
      implicit none
      integer icut5,cut5,i
      real(ki), dimension(4), intent(in) :: p0, e1, e2
      complex(ki), intent(in) :: c5
      complex(ki), dimension(4), intent(in) ::  e3, e4
      do i=1,4
         sav5p0(icut5,i)=p0(i)
         sav5e1(icut5,i)=e1(i)
         sav5e2(icut5,i)=e2(i)
         sav5e3(icut5,i)=e3(i)
         sav5e4(icut5,i)=e4(i)
      enddo
         savc5(icut5)=c5
         savcut5(icut5)=cut5
  end subroutine store5

  subroutine store4(icut4,cut4,L3,p0,e1,e2,e3,e4,c4)
      implicit none
      real(ki), dimension(4), intent(in) :: L3, p0, e1, e2
      complex(ki), dimension(4), intent(in) :: e3, e4
      complex(ki), dimension(0:4), intent(in) :: c4
      integer icut4,cut4,i
      do i=1,4
         savL3(icut4,i)=L3(i)
         sav4p0(icut4,i)=p0(i)
         sav4e1(icut4,i)=e1(i)
         sav4e2(icut4,i)=e2(i)
         sav4e3(icut4,i)=e3(i)
         sav4e4(icut4,i)=e4(i)
      enddo
      do i=0,4
         savc4(icut4,i)=c4(i)
      enddo
         savcut4(icut4)=cut4
  end subroutine store4

  subroutine store3(icut3,cut3,p0,e1,e2,e3,e4,c3)
      implicit none
      real(ki), dimension(4), intent(in) :: p0, e1, e2
      complex(ki), dimension(4), intent(in) :: e3, e4
      complex(ki), dimension(0:9), intent(in) :: c3
      integer icut3,cut3,i
      do i=1,4
         sav3p0(icut3,i)=p0(i)
         sav3e1(icut3,i)=e1(i)
         sav3e2(icut3,i)=e2(i)
         sav3e3(icut3,i)=e3(i)
         sav3e4(icut3,i)=e4(i)
      enddo
      do i=0,9
         savc3(icut3,i)=c3(i)
      enddo
         savcut3(icut3)=cut3
  end subroutine store3

  subroutine store2(icut2,cut2,p0,e1,e2,e3,e4,c2)
      implicit none
      real(ki), dimension(4), intent(in) :: p0, e1, e2
      complex(ki), dimension(4), intent(in) :: e3, e4
      complex(ki), dimension(0:9), intent(in) :: c2
      integer icut2,cut2,i
      do i=1,4
         sav2p0(icut2,i)=p0(i)
         sav2e1(icut2,i)=e1(i)
         sav2e2(icut2,i)=e2(i)
         sav2e3(icut2,i)=e3(i)
         sav2e4(icut2,i)=e4(i)
      enddo
      do i=0,9
         savc2(icut2,i)=c2(i)
      enddo
         savcut2(icut2)=cut2
  end subroutine store2

  subroutine store1(icut1,cut1,p0,e1,e2,e3,e4,c1)
      implicit none
      real(ki), dimension(4), intent(in) :: p0, e1, e2
      complex(ki), dimension(4), intent(in) :: e3, e4
      complex(ki), dimension(0:4), intent(in) :: c1
      integer :: icut1,cut1,i
      do i=1,4
         sav1p0(icut1,i)=p0(i)
         sav1e1(icut1,i)=e1(i)
         sav1e2(icut1,i)=e2(i)
         sav1e3(icut1,i)=e3(i)
         sav1e4(icut1,i)=e4(i)
      enddo
      do i=0,4
         savc1(icut1,i)=c1(i)
      enddo
         savcut1(icut1)=cut1
  end subroutine store1

  function res5(icut5,mu2)
      implicit none
      integer :: icut5
      complex(ki) :: res5
      real(ki) :: mu2
      Res5=savc5(icut5)*mu2
!      Res5=savc5(icut5)*mu2**2
  end function res5

  function res4(icut4,q,mu2)
      implicit none
      integer icut4,i
      real(ki) :: L3(4), mu2
      complex(ki), dimension(4) :: e3, e4, q, pm
      complex(ki) :: c4(0:4)
      complex(ki) :: res4
      do i=1,4
         L3(i)=savL3(icut4,i)
         pm(i)=sav4p0(icut4,i)+q(i)
         e3(i)=sav4e3(icut4,i)
         e4(i)=sav4e4(icut4,i)
      enddo
      do i=0,4
         c4(i)=savc4(icut4,i)
      enddo
      res4=poly4(c4,pm,mu2,L3,e3,e4)
  end function res4

  function res3(icut3,q,mu2)
      implicit none
      integer icut3,i
      real(ki) :: mu2
      complex(ki), dimension(4) :: e3, e4, q, pm
      complex(ki) :: c3(0:9)
      complex(ki) :: res3

      do i=1,4
         pm(i)=sav3p0(icut3,i)+q(i)
         e3(i)=sav3e3(icut3,i)
         e4(i)=sav3e4(icut3,i)
      enddo
      do i=0,9
         c3(i)=savc3(icut3,i)
      enddo
      res3=poly3(c3,pm,mu2,e3,e4)
  end function res3

  function res2(icut2,q,mu2)
      implicit none
      integer icut2,i
      real(ki) :: e2(4), mu2
      complex(ki) :: e3(4),e4(4),q(4),pm(4),c2(0:9)
      complex(ki) :: res2
      do i=1,4
         pm(i)=sav2p0(icut2,i)+q(i)
         e2(i)=sav2e2(icut2,i)
         e3(i)=sav2e3(icut2,i)
         e4(i)=sav2e4(icut2,i)
      enddo
      do i=0,9
         c2(i)=savc2(icut2,i)
      enddo
      res2=poly2(c2,pm,mu2,e2,e3,e4)
  end function res2

  function res1(icut1,q)
      implicit none
      integer icut1,i
      real(ki) ::  e1(4), e2(4)
      complex(ki) :: e3(4), e4(4), q(4), pm(4), c1(0:4)
      complex(ki) :: res1
      do i=1,4
         pm(i)=sav1p0(icut1,i)+q(i)
         e1(i)=sav1e1(icut1,i)
         e2(i)=sav1e2(icut1,i)
         e3(i)=sav1e3(icut1,i)
         e4(i)=sav1e4(icut1,i)
      enddo
      do i=0,4
         c1(i)=savc1(icut1,i)
      enddo
      res1=poly1(c1,pm,e1,e2,e3,e4)
  end function res1

end module mrestore
